`timescale 1 ns/1 ns
module sample_top_tb();

reg clkin_50		 = 0;
reg clkin_100m_p_0 = 0;
reg cpu_resetn		 = 0;

wire [35:0]	pfn;
wire [16:0]	hsma_tx_d_p;
wire [2:1]  hsma_clk_out_p;

parameter period0 = 10;   
parameter period1 = 5;   
        

 always#(period0)begin
   clkin_50 		= ~clkin_50;
end

always#(period1)begin
   clkin_100m_p_0 = ~clkin_100m_p_0;
end


initial begin
  cpu_resetn = 0;
  #1000
  cpu_resetn = 1;
end

sample_top sample_top_inst
(
	.clkin_50			(clkin_50) ,	// input  clkin_50_sig
	.clkin_100m_p_0	(clkin_100m_p_0) ,	// input  clkin_100m_p_0_sig
	.cpu_resetn			(cpu_resetn) ,	// input  cpu_resetn_sig
	.hsma_tx_d_p		(hsma_tx_d_p) ,	// output [16:0] hsma_tx_d_p_sig
	.hsma_rx_d_p		(hsma_tx_d_p) ,	// input [16:0] hsma_rx_d_p_sig
	.hsma_clk_in_p		(hsma_clk_out_p) ,	// input [2:1] hsma_clk_in_p_sig
	.hsma_clk_out_p	(hsma_clk_out_p) ,	// output [2:1] hsma_clk_out_p_sig
	.pfn					(pfn) 	// output [34:0] pfn_sig
);

endmodule

