module test_pattern_chk
#(
	parameter data_width		= 35,
	parameter INV_PATTERN	= 0,
	parameter POLY_LENGHT	= 7,
	parameter POLY_TAP		= 6

)
(
	input									clk,
	input									reset_n,
	output reg							aln_done,
	output reg							rx_d_aln,
	input  [data_width-1:0]			data_in,
	output [data_width-1:0]			pfn
);

reg [1:0]	state;
reg			prbs_en;

reg [3:0]	wait_cnt;

parameter 	idle			= 0;
parameter 	aln_chk		= 1;
parameter 	aln_wait		= 2;
parameter 	nomal			= 3;
//USER ALN TR
parameter aln_pattern	= 35'b11011_11111_11111_11110_11100_11000_10000;


always@(posedge clk or negedge reset_n)begin
	if(!reset_n)begin
		state		<= idle;
	end
	else begin
		case(state)
			idle:begin
				prbs_en	<= 0;
				state		<= aln_chk;
				wait_cnt	<= 'b0;
				aln_done	<= 'b0;
			end
			aln_chk:begin
				if(aln_pattern == data_in)begin
					state		<= nomal;
					aln_done <= 1'b1;
				end
				else begin
					state		<= aln_wait;
					rx_d_aln	<= 1'b1;
					wait_cnt	<= 'b0;
				end
			end
			aln_wait:begin
				rx_d_aln <= 1'b0;
				wait_cnt	<= wait_cnt + 4'b0001;
				if(wait_cnt	== 4'b1111)begin
					state		<= aln_chk;
				end
			end
			nomal:begin
				prbs_en	<= 1'b1;
			end
			default:begin
				state		<= idle;
			end
		endcase
	end
end


prbs_gen_chk prbs_gen_inst
(
	.RST					(!reset_n) ,	// input  RST_sig
	.CLK					(clk) ,			// input  CLK_sig
	.DATA_IN				(data_in) ,		// input [NBITS-1:0] DATA_IN_sig
	.EN					(prbs_en) ,		// input  EN_sig
	.DATA_OUT			(pfn) 			// output [NBITS-1:0] DATA_OUT_sig
);

//   CHK_MODE     : true =>  check mode,false => generate mode
defparam prbs_gen_inst.CHK_MODE 		= 1;
defparam prbs_gen_inst.INV_PATTERN 	= INV_PATTERN;
defparam prbs_gen_inst.POLY_LENGHT 	= POLY_LENGHT;
defparam prbs_gen_inst.POLY_TAP 		= POLY_TAP;
defparam prbs_gen_inst.NBITS			= data_width;

endmodule