module test_pattern_gen2
#(
	parameter data_width		= 35,
	parameter INV_PATTERN	= 0,
	parameter POLY_LENGHT	= 7,
	parameter POLY_TAP		= 6

)
(
	input									clk,
	input									reset_n,
	input									err_inj,
	input									aln_done,
	output reg [data_width-1:0]	data_out
);

reg [1:0]	state;
reg			prbs_en;

wire [data_width-1:0] prsb_data;

parameter 	idle			= 0;
parameter 	aln_tr		= 1;
parameter 	nomal			= 2;
//USER ALN TR
parameter aln_pattern	= 7'b1110_111;


always@(posedge clk or negedge reset_n)begin
	if(!reset_n)begin
		data_out	<= 'b0;
		state		<= idle;
	end
	else begin
		case(state)
			idle:begin
				data_out	<= 0;
				prbs_en	<= 0;
				state		<= aln_tr;
			end
			aln_tr:begin
				data_out	<= aln_pattern;
				if(aln_done)begin
					state		<= nomal;
				end
			end
			nomal:begin
				prbs_en	<= 1'b1;
				data_out	<= prsb_data;
			end
			default:begin
				data_out	<= 0;
				state		<= idle;
			end
		endcase
	end
end


prbs_gen_chk prbs_gen_inst
(
	.RST					(!reset_n) ,					// input  RST_sig
	.CLK					(clk) ,							// input  CLK_sig
	.DATA_IN				({data_width{err_inj}}) ,	// input [NBITS-1:0] DATA_IN_sig
	.EN					(prbs_en) ,						// input  EN_sig
	.DATA_OUT			(prsb_data) 					// output [NBITS-1:0] DATA_OUT_sig
);

//   CHK_MODE     : true =>  check mode,false => generate mode
defparam prbs_gen_inst.CHK_MODE 		= 0;
defparam prbs_gen_inst.INV_PATTERN 	= INV_PATTERN;
defparam prbs_gen_inst.POLY_LENGHT 	= POLY_LENGHT;
defparam prbs_gen_inst.POLY_TAP 		= POLY_TAP;
defparam prbs_gen_inst.NBITS			= data_width;

endmodule
